-- 活跃战令
checkRequire("Lua_IconShowItem");
Lua_ActiveWarPanel = class("Lua_ActiveWarPanel", Lua_DisplayObject)
function Lua_ActiveWarPanel:ctor(p)
	self:superCall("ctor", p, "ActiveWarPanel_skin");
end

function Lua_ActiveWarPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 625, 552, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_ActiveWarItem, 625, 146, 1);
	self.rewardList:setLocation(0, -86, 0);

	-- 初级战令解锁道具显示
	self.primaryLockItem = Lua_IconShowItem.new(self.content);
	self.primaryLockItem:setTextFieldStyle(24);
	self.primaryLockItem:setLocation(-36, 211, 0);
	self.primaryLockItem:setBg(false);

	self.primaryWarBg:addClickFuntion(self, self.gotoUnlockPrimary);
	self.seniorWarBg:addClickFuntion(self, self.gotoUnlockSenior);

	self:addLuaEvent("ACTIVE_WAR", self, self.updatePanel);
	Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskActiveWarInfo();
end

function Lua_ActiveWarPanel:updatePanel()
	-- 倒计时
	self.remainTime = DataCenter.taskData.activeWarRTime;
	self:startTimer();
	self:updateWarsState();

	local acitveWarList = DataCenter.taskData.acitveWarList;
	if acitveWarList == nil then
		return;
	end
	self.rewardList:setArrayData(acitveWarList);

	if self.firstEnter == nil then
		self.firstEnter = true;
		local moveIndex = DataCenter.taskData.activeWarShowIndex;
		moveIndex = moveIndex > 1 and (moveIndex - 1) or moveIndex;
		self.rewardList:moveToIndex(moveIndex, true);
	end
end

-- 战令状态显示
function Lua_ActiveWarPanel:updateWarsState()
	-- 初级战令解锁道具显示
	local lockRewardTVo = DataCenter.taskData.lockRewardTVo;
	self.primaryLockItem:setIcon(lockRewardTVo.iconAtlas, lockRewardTVo.iconSprite, lockRewardTVo.iconWidth, lockRewardTVo.iconHeight);
	self.primaryLockItem:setCount(lockRewardTVo.count, "000000");

	-- 初级战令解锁状态显示
	local state = DataCenter.taskData.primaryWarLockState;
	local posY = state == 1 and 2 or 11;
	self.primaryTipTxt.text = state == 1 and LanUtil.getValue(202815) or LanUtil.getValue(202814);
	self.primaryWarName:setLocation(2, posY);
	self.primaryLockSp:setEnable(state == 0);
	self.primaryLockItem:setEnable(state == 0);
	self.primaryUnlockTxt:setEnable(state == 0);

	-- 高级战令解锁状态显示
	state = DataCenter.taskData.seniorWarLockState;
	posY = state == 1 and 2 or 11;
	local rechargeId = DataCenter.taskData.rechargeId;
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);	
	self.seniorRechargeTxt.text = LanUtil.formateStr(202817, rechargeInfo.money);--"元";
	self.seniorTipTxt.text = state == 1 and LanUtil.getValue(202815) or LanUtil.getValue(202816);
	self.seniorWarName:setLocation(2, posY);
	self.seniorLockSp:setEnable(state == 0);
	self.seniorUnlockTxt:setEnable(state == 0);
	self.seniorRechargeTxt:setEnable(state == 0);

	-- 活跃度
	self.activePointTxt.text = DataCenter.taskData.activeWarPoint;
end

function Lua_ActiveWarPanel:gotoUnlockPrimary()
	local state = DataCenter.taskData.primaryWarLockState;
	if state == 1 then 
		return;
	end

	Lua_WindowUtil.openWin("Lua_UnlockPrimaryWarWindow", Lua_WinParam.ACTION_OPEN, Lua_TaskData.primaryWarStyle);
end

function Lua_ActiveWarPanel:gotoUnlockSenior()
	local state = DataCenter.taskData.seniorWarLockState;
	if state == 1 then 
		return;
	end

	local lockItem = DataCenter.taskData.rechargeId;
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(lockItem);
	DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
end

function Lua_ActiveWarPanel:startTimer()
	local residueTime = self.remainTime - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		if self.countDown ~= true then
			self.countDown = true;
			Lua_CommonUtil.addTimer("Lua_ActiveWarPanel", 1, self, self.updateLeftTime);
		end
	else
		residueTime = 0;
	end
	self.residueTime.text = LanUtil.formateStr(202813, Lua_TimeTransform.transSeconds16(residueTime, true, true, true));
end

function Lua_ActiveWarPanel:updateLeftTime()
	local residueTime = self.remainTime - DataCenter.roleData.serverTime;
	if residueTime <= 0 then
		residueTime = 0;
		self:endTimer();
	end
	self.residueTime.text = LanUtil.formateStr(202813, Lua_TimeTransform.transSeconds16(residueTime, true, true, true));
end

function Lua_ActiveWarPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_ActiveWarPanel:updateData()
end

function Lua_ActiveWarPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.primaryLockItem ~= nil then
		self.primaryLockItem:dispose();
		self.primaryLockItem = nil;
	end
	self:endTimer();
	
    self:superCall("dispose");
end





--------------------------------------------------





Lua_ActiveWarItem = class("Lua_ActiveWarItem",Lua_ListCell)
function Lua_ActiveWarItem:ctor(p)
	self:superCall("ctor", p, "ActiveWarItem_skin");
end

function Lua_ActiveWarItem:buildShowItem()
	self:superCall("buildShowItem");

	-- 初级战令奖励
	self.primaryRewardItem = Lua_AWarPrimaryItem.new(self.content);
	self.primaryRewardItem:setLocation(-41, 0, 0);
	self.primaryRewardItem.content.name = "primaryRewardItem";

	-- 高级战令奖励列表
	self.seniorRewardList = Lua_DragList.new(self.content, 224, 112, Lua_AxisDefine.Horizontal);
	self.seniorRewardList:setListCell(Lua_AWarPrimaryItem, 112, 112, 1);
	self.seniorRewardList:setLocation(191, 0, 0);
	self.seniorRewardList.content.name = "seniorRewardList";
	self:setSubList(self.seniorRewardList);
end

function Lua_ActiveWarItem:setData(data)
	if data == nil then
		return;
	end

	local rewardVo = DataCenter.taskData:getWarById(data.acitveWarId);
	if rewardVo == nil then 
		return;
	end

	self.activeWarBar:setEnable(data.index ~= 1);

	self.tipTxt.text = rewardVo.process;

	-- 初级战令
	local rewardList = rewardVo.primaryRewardList;
	local rewardId = rewardVo.id;
	local param = DataCenter.taskData:dealwithWarStateData(Lua_TaskData.primaryWarStyle, rewardId);
	self.primaryRewardItem:setData(param[1]);

	-- 高级战令
	rewardList = rewardVo.seniorRewardList;
	param = DataCenter.taskData:dealwithWarStateData(Lua_TaskData.seniorWarStyle, rewardId);
	self.seniorRewardList.canDrag = #rewardList > 2;
	self.seniorRewardList:setArrayData(param);

	-- 进度条
	self:showProcessBar(rewardId, data.index);
end

-- 进度条的显示
function Lua_ActiveWarItem:showProcessBar(rewardId, data_index)
	local curValue, maxValue = DataCenter.taskData:calculateProcessBar(rewardId, data_index);
	if maxValue == nil then
		return;
	end

	self.activeWarBar:setMaxValue(maxValue);
	self.activeWarBar:setValue(curValue);
	-- self.activeWarBar:setText(curValue .."/".. maxValue);
end

function Lua_ActiveWarItem:onPressClick()
	self.primaryRewardItem:onPressClick();
end

function Lua_ActiveWarItem:dispose()
	if self.primaryRewardItem ~= nil then
		self.primaryRewardItem:dispose();
		self.primaryRewardItem = nil;
	end
	if self.seniorRewardList ~= nil then
		self.seniorRewardList:dispose();
		self.seniorRewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_AWarPrimaryItem = class("Lua_AWarPrimaryItem",Lua_ListCell)
function Lua_AWarPrimaryItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AWarPrimaryItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_ItemIcon.new(self.content);
	self.rewardItem:updateBound();
	self.rewardItem:setCanClick(false);

	self.receivedSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_14", 0, 0, 100, 100);
end

function Lua_AWarPrimaryItem:setData(data)
	if data == nil then
		return;
	end

	self.rewardId = data.rewardId; -- 奖励id
	self.lockState = data.lockState; -- 解锁状态
	self.activeWarStyle = data.activeWarStyle; -- 战令类型
	self.rewardState = data.rewardState; -- 奖励领取状态

	-- 奖励Item显示
	self.tvo = Lua_ToolVo.createToolVo(data.rewardData[1], data.rewardData[2]);
	self.rewardItem:setData(self.tvo);

	self.receivedSp:setEnable(self.rewardState == 2); -- 已领取图标是否显示
	self:showRedDot(self.rewardState == 1 and self.lockState == 1);-- 可领取红点是否显示
end

function Lua_AWarPrimaryItem:onPressClick(go)
	if self.rewardItem == nil then
		return;
	end

	local winPos = LuaUtil.getTouchPosInverseTf(self.mainContent.transform);
	if self.rewardItem.isActive and self.rewardItem:checkInBound(winPos.x, winPos.y) then
		-- 奖励不可领取（即活跃度未达标时）或已领取时显示道具信息
		if self.rewardState ~= 1 then
			DataCenter.packUtil:showItemInfo(self.tvo);
		else
			-- 活跃度达标，但未解锁时，弹解锁窗口
			if self.lockState == 0  then
				if self.activeWarStyle == Lua_TaskData.primaryWarStyle then
					Lua_WindowUtil.openWin("Lua_UnlockPrimaryWarWindow", Lua_WinParam.ACTION_OPEN, self.activeWarStyle);
				elseif self.activeWarStyle == Lua_TaskData.seniorWarStyle then
					local lockItem = DataCenter.taskData.rechargeId;
					local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(lockItem);
					DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
							tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
				end
			-- 活跃度达标且该战令解锁时，领取奖励
			elseif self.lockState == 1  then
				Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskActiveWarReward(self.rewardId, self.activeWarStyle);
			end
		end
	end
end

-- 红点
function Lua_AWarPrimaryItem:showRedDot(val)
    if val == true then
        if self.redPoint == nil then
            self.redPoint = Lua_RedPointIcon.new(self.content);
            self.redPoint:setLocation(45, 45, 0);
            self.redPoint:createRedPointEff();
        end
        self.redPoint:updateRedPointShow(true);
    else
        if self.redPoint ~= nil then
            self.redPoint:updateRedPointShow(false);
        end
    end
end

function Lua_AWarPrimaryItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.receivedSp ~= nil then
		self.receivedSp:dispose();
		self.receivedSp = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end

	self:superCall("dispose");
end