-- 日常任务
checkRequire("Lua_DailyTaskPanel"); -- 任务
checkRequire("Lua_AchievementTaskPanel"); -- 成就任务
checkRequire("Lua_ActiveWarPanel"); -- 活跃战令任务
Lua_TaskBaseWindow = class("Lua_TaskBaseWindow", Lua_Window)
function Lua_TaskBaseWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TaskBaseWindow";
	self.skinName = "TaskBaseWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showClose = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TaskBaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(293, 440);

	self.panelInfoArr = Array();
	self.panelInfoArr:add({id = Lua_TaskData.dailyTask, 		  panel = Lua_DailyTaskPanel, 		textStr = LanUtil.getValue(202802), redPointId = Lua_RedPointList.Task_DailyTab,   panelParam = Lua_TaskData.dailyTask});
	self.panelInfoArr:add({id = Lua_TaskData.weeklyTask, 		  panel = Lua_DailyTaskPanel, 		textStr = LanUtil.getValue(202803), redPointId = Lua_RedPointList.Task_WeeklyTab,  panelParam = Lua_TaskData.weeklyTask});
	-- self.panelInfoArr:add({id = Lua_TaskData.activeWarTask, 	  panel = Lua_ActiveWarPanel, 		textStr = LanUtil.getValue(202809), redPointId = Lua_RedPointList.Task_ActiveWarTab, openId = 10223});
	self.panelInfoArr:add({id = Lua_TaskData.achievementTaskTask, panel = Lua_AchievementTaskPanel, textStr = LanUtil.getValue(202804), redPointId = Lua_RedPointList.Task_AchievementTab});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setLocation(0, -427, 0);
	self.btnList:setButtonStyle("common_altas_1", "ui_common_tab_02_s", "ui_common_tab_02", 222, 70, 0.01, 1);
	self.btnList:setButtonText(1, 6, "5C504B", "8B5E34", 30, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_013", 0, 0, 0, -6);
	self.btnList:setButtonItem(222, 70);
	self.btnList:setRedPoint(80, 23);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(self.panelInfoArr);

	self:addLuaEvent("SELECT_DAILYTASK_PANEL", self, self.updatePanel);
end

function Lua_TaskBaseWindow:showWin(param)
	local toIndex;
	if type(param) == "table" and param.main_id ~= nil then
		toIndex = param.main_id;
	elseif type(param) == "string" or type(param) == "number" then
		toIndex = tonumber(param);
	end

	if toIndex ~= nil then
		toIndex = self:getTheActIdx(toIndex);
	else
		toIndex = DataCenter.taskData:getSelectedPanel();
		toIndex = self:getTheActIdx(toIndex); -- 根据是否有奖励可领取走此函数（服务端数据）
	end
	self.btnList:setSelected(toIndex);
	-- self.curPanel:updateData();
end

function Lua_TaskBaseWindow:updatePanel()
	self.curPanel:updateData();
end

-- 跳到对应类型页签
function Lua_TaskBaseWindow:getTheActIdx(index)
	local typeIdx = 1;
	for i = 1, self.panelInfoArr:getSize() do
		if index == self.panelInfoArr[i].id then
			typeIdx = i;
			break;
		end
	end
	return typeIdx;
end

function Lua_TaskBaseWindow:onBtnClick(val)
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.curPanel = self.panelInfoArr[val].panel.new(self.content);

	local param = self.panelInfoArr[val].panelParam;
	if param ~= nil then
		self.curPanel:setPanelType(self.panelInfoArr[val].panelParam);
	end
	self.curPanel:setSiblingIndex(5);
	self.curPanel:updateData();
end

function Lua_TaskBaseWindow:dispose()
	if self.panelInfoArr ~= nil then
		self.panelInfoArr:dispose();
		self.panelInfoArr:clear();
		self.panelInfoArr = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	self:superCall("dispose");
end