Lua_UnlockPrimaryWarWindow = class("Lua_UnlockPrimaryWarWindow", Lua_TipsBaseWindow)
function Lua_UnlockPrimaryWarWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_UnlockPrimaryWarWindow";
	-- self.skinName = "BuyCashGoodsWindow_skin";
	self.showTitle = true;
	self.titleAtlas = "shop_atlas_1";
	self.titleSprite = "ui_gmwp_title_01";
	self.bShowTitleDeco = true;
	self.showClose = true;
	self.isClickClose = true;
	self.showCancel = false;
end

function Lua_UnlockPrimaryWarWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.unLockTipLTxt = UICreate.createLabel(self.content, "是否花费", -127, 19, 150, 50, 36);
	self.unLockTipLTxt.colorStr = Lua_ColorDefine.transColor("000000");
	self.unLockTipLTxt.name = "unLockTipLTxt";

	self.unLockTipRTxt = UICreate.createLabel(self.content, "购买?", 173, 19, 150, 50, 36);
	self.unLockTipRTxt.colorStr = Lua_ColorDefine.transColor("000000");
	self.unLockTipRTxt.name = "unLockTipRTxt";

	-- 高级战令解锁条件文本
	self.unLockTipTxt = UICreate.createLabel(self.content, "", 50, 19, 150, 50, 36);
	self.unLockTipTxt.colorStr = Lua_ColorDefine.transColor("000000");
	self.unLockTipTxt.name = "unLockTipTxt";

	-- 初级战令解锁道具
	self.primaryLockItem = Lua_IconShowItem.new(self.content);
	self.primaryLockItem:setTextFieldStyle(36);
	self.primaryLockItem:setLocation(50, 19, 0);
	self.primaryLockItem:setBg(false);

	-- 取消按钮
	local half_h = self.h / 2;
	self.cancelButton = UICreate.createButton(self.content, LanUtil.getValue(105029), 0, 0, 177, 58);
	self.cancelButton.name = "cancelButton";
	self.cancelButton:setStyle(1);
	self.cancelButton.txt.colorStr = Lua_ColorDefine.transColorStr("8B5E34");
	self.cancelButton.label = "取消";
	self.cancelButton:setLocation(-145, -half_h + 84.5, 0);
	self.sureBtn:setLocation(145, -half_h + 84.5, 0); 

	self.cancelButton:addClickFuntion(self, self.hide);
end

function Lua_UnlockPrimaryWarWindow:showWin(param)
	self:superCall("showWin", param);

	if param == Lua_TaskData.primaryWarStyle then	
		local lockItem = DataCenter.taskData.lockRewardTVo;	
		self.primaryLockItem:setIcon(lockItem.iconAtlas, lockItem.iconSprite , lockItem.iconWidth, lockItem.iconHeight);
		self.primaryLockItem:setCount(lockItem.count, "000000");
		self.primaryLockItem.count:SetDimensions(80, 50);
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(DataCenter.taskData.rechargeId);
		self.unLockTipTxt.text = rechargeInfo.money.."元";
	end
	self.primaryLockItem:setEnable(param == Lua_TaskData.primaryWarStyle);
	self.unLockTipTxt:setEnable(param ~= Lua_TaskData.primaryWarStyle);
end

function Lua_UnlockPrimaryWarWindow:onSureBtnClick(go)
	if self.showData == Lua_TaskData.primaryWarStyle then
		local lockItem = DataCenter.taskData.lockRewardTVo;
		local hasCount = DataCenter.packData:getItemCountById(lockItem.id);
		if hasCount < lockItem.count then
			DataCenter.packUtil:openPathWindow(lockItem);
		else
			Lua_ProxyManager.getProxy("Lua_TaskProxy"):sTaskActiveWarUnlockPrimary();
		end
	end
	self:hide();
end

function Lua_UnlockPrimaryWarWindow:dispose()
	if self.unLockTipLTxt ~= nil then
		self.unLockTipLTxt:dispose();
		self.unLockTipLTxt = nil;
	end
	if self.unLockTipRTxt ~= nil then
		self.unLockTipRTxt:dispose();
		self.unLockTipRTxt = nil;
	end
	if self.unLockTipTxt ~= nil then
		self.unLockTipTxt:dispose();
		self.unLockTipTxt = nil;
	end
	if self.primaryLockItem ~= nil then
		self.primaryLockItem:dispose();
		self.primaryLockItem = nil;
	end
	if self.cancelButton ~= nil then
		self.cancelButton:dispose();
		self.cancelButton = nil;
	end

	self:superCall("dispose");
end